/*  gtail
 *  Copyright (C) 1999 Didier Remy
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * $Log: gtailsig.c,v $
 * Revision 1.6  1999/12/30 08:55:16  didier
 * Internationalisation
 *
 * Revision 1.5  1999/12/21 18:14:45  didier
 * Gestion de l'affichage du rsultat d'une commande
 *   donner en ligne de commande par le texte "|cmd"
 *
 * Gestion de session
 *   fichier .gtail.session modifiable  la main
 *   sauvegarde de session automatique en fin d'excution
 *   reprise des fichiers/commandes ouvert lors de la dernire sauvegarde si aucun
 *     paramtre en ligne de commande
 *
 * Prise en compte du rpertoire de pixmaps pour les boutons rapides
 *
 * Possibilit de fermer une vue en cliquant dessus avec le 3ime bouton
 *
 * Revision 1.4  1999/11/20 15:37:01  didier
 * Affiche une toile (*)  la fin du nom si le contenu du fichier  t
 * modifi depuis la dernire visite de la page par l'utilisateur
 *
 * Utilisation de ma fonction (xt)basename, celle de Linux/Debian n'est
 * pas documente
 *
 * La page du notebook n'est cre que lorsque le fichier a pu tre
 * ouvert. Seul le widget text est  dtruire.
 *
 * Gestion des vnements destroy du WM et du changement de page pour
 * l'*' dans le nom des fichiers modifis mais pas encore visits.
 *
 * Revision 1.3  1999/11/10 20:35:34  didier
 * Support de memwatch
 * Ajout de scrollbar (verticale) au widget texte
 *
 */

/* include produced by glade */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "gtailsig.h"
#include "gtailsrc.h"
#include "support.h"

/* includes I need */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "file.h"
#include "session.h"
#include "option.h"

/* flag qui indique si le timeout pour la lecture priodique des stream ouvert
 * a dj t lanc */
int timeout_tag = -1;

/* initialis dans main.c  la cration de l'interface. ncessaire pour le
 * passage d'un toplevel  l'autre */
GtkWidget *topgtail = NULL;

int
on_timeout( gpointer          data)
{
  GtkText *text;       /* le widget text ou on va insrer la fin du fichier */
  int ind, count = -1; /* l'indice dans xfi et le nombre d'octets lus */
  char fileline[8192]; /* un buffer pour la lecture du fichier */
  char *name = NULL, *p;
  GtkWidget *notebook, *page;
#define NBREADMAX 1
  int nbread;

  /* lit tous les fichiers en commencant par le premier */
  ind = 0;
  while (xfi[ind].has_changed != LAST) /* tant que pas le dernier */
  {
    if (xfi[ind].has_changed != UNUSED &&  /* lit s'il est ouvert */
	xfi[ind].has_changed != IS_DEAD)   /* et si cmd active */
    {
      /*fprintf(stderr, "read %d\n", ind);*/
      text = GTK_TEXT(xfi[ind].w);
      /*gtk_text_freeze (text);*/
      nbread = 0;
      while ((nbread++ < NBREADMAX) &&
	     (count = read(xfi[ind].fd, fileline, 8192)) > 0/*0=EOF -1=ERR*/)
      {
	gtk_text_insert(text, NULL, NULL, NULL,	fileline, count);

#if 0
	if ((p = strrchr(fileline, '\n')) != NULL)
	{
	  int len;
	  gchar *line;
	  /* recherche une regexp */
	  /* !!! NE CHERCHE PAS LIGNE PAR LIGNE !!! */
	  len = gtk_text_get_length(text);
	  end_pos = (p - fileline); /* n'inclut pas le \n final */
	  line = gtk_editable_get_chars(text, xfi[ind].last_new_line, end_pos);
	  if (match(line, &start, &stop))
	    printf("MATCH %d-%d\n", start, stop);
	  g_free(line);
	  xfi[ind].last_new_line = end_pos + 1; /* sur le dernier \n */
	}
#endif

	/* else laisse le a IS_DEADNCHANGED pour continuer a le lire */
	if (xfi[ind].has_changed != IS_DEADNCHANGED)
	  xfi[ind].has_changed = CHANGED;
      }
      /*gtk_text_thaw (text);*/
    }
    if (xfi[ind].has_changed == CHANGED ||
	xfi[ind].has_changed == IS_DEADNCHANGED)
    {
      notebook = lookup_widget(topgtail, "NoteBook");
      /* n'ajoute l'* que si on ne regarde pas cette page */
      if (ind != gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook)))
      {
	name = xtbasename(xfi[ind].filename);
	if ((name = (char *)realloc(name, (strlen(name) + 5) * sizeof(char)))
	    == NULL)
	{
	  fprintf(stderr, "on_timeout:can't realloc\n");
	  /* pour le moment plus de mm mais plus tard peut-tre */
	  return TRUE;
	}
	strcat(name, " *");
	if (xfi[ind].has_changed == IS_DEADNCHANGED)
	  strcat(name, "X*"); /* ajoute ca pour montrer cmd fini et modif */

	page = gtk_notebook_get_nth_page (GTK_NOTEBOOK(notebook), ind);
	gtk_notebook_set_tab_label_text (GTK_NOTEBOOK(notebook), page, name);
	free(name);
      }
      else
      {
	if (count <= 0) /* on a tout lu, on change l'tat */
	{
	  if (xfi[ind].has_changed == CHANGED)
	    xfi[ind].has_changed = NOT_CHANGED;
	  else
	    xfi[ind].has_changed = IS_DEAD;
	}
      }
    }
    ind++;
  }

  return TRUE; /* ne dsactive pas ce timeout callbak */
}

/*
 * Used to add a new page (view/frame what you want) to display a file/cmd
 * contained in path.
 * mode=0 for a file
 * mode=1 for a cmd
 * Retour : l'indice renvoy par add_stream (-1=erreur)
 */
int
AddNoteBookPage(GtkNotebook *notebook, char *path, int mode)
{
  char filename[1024]; /* le texte du label */
  char *slash; /* temp pour trouver le / pour le texte du label */
  GtkWidget *text, *label, *table, *vscrollbar, *hscrollbar;
  int ind = -1;

  /* enleve le nom du repertoire pour le label du notebook
   * les noms de fichiers passs en paramtre ne contiennent pas forcment de /
   */
  if (mode == 0)
  {
    slash = xtbasename(path);
    strcpy(filename, slash);
    free(slash);
  }
  else
    strcpy(filename, path);

  text = gtk_text_new(NULL, NULL);

  /* ajoute ce fichier a la liste xfi */
  if ((ind = add_stream(path, mode, text)) == -1)
  {
    fprintf(stderr, "AddNoteBookPage:echec  l'ouverture du fichier %s\n",
	    path);
    g_free(text);
  }
  else
  {
    /* modifie le widget text en read-only */
    gtk_text_set_editable(GTK_TEXT(text), FALSE);
    gtk_widget_show(text);
    /* cre le label et le text a insrer dans le notebook */
    label = gtk_label_new(filename);
    /*faire une table ici*/
    table = gtk_table_new(2, 2, FALSE);
    gtk_widget_show(table);

    gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		      GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    /* cree la barre de dfilement verticale et attache la a la table */
    vscrollbar = gtk_vscrollbar_new (GTK_TEXT(text)->vadj);

    gtk_table_attach (GTK_TABLE (table), vscrollbar, 1, 2, 0, 1,
		      GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    gtk_widget_show (vscrollbar);
    
    gtk_notebook_append_page(notebook, table, label);
    /* marche pas pour le plus intressant, le tab_label */
    /*gtk_signal_connect( GTK_OBJECT(text), "button_release_event",
			GTK_SIGNAL_FUNC(remove_page), 
			(gpointer)ind);
    gtk_signal_handlers_destroy( GTK_OBJECT(gtk_notebook_get_tab_label(notebook, gtk_notebook_get_nth_page (notebook, ind))) );
    gtk_signal_connect_after( GTK_OBJECT(gtk_notebook_get_tab_label(notebook, gtk_notebook_get_nth_page (notebook, ind))), "button_release_event",
	 		GTK_SIGNAL_FUNC(remove_page), 
			(gpointer)ind);*/
    /* lance la lecture des fichiers la 1ere fois */
    if (timeout_tag == -1)
      timeout_tag = gtk_timeout_add(1000, on_timeout, NULL);
  }

  return ind;
}

/*
 * Called each time a child (forked) died
 * used to change its display status
 */
void
a_child_is_dead(int sig)
{
  int status;
  pid_t pid;

  /*puts("a_child_is_dead:fils mort");*/

  if ((pid = wait(&status)) == (int)-1)
  {
    perror("a_child_is_dead");
  }
  else
  {
    int i = 0;

    /*fprintf(stderr, "pid:%d\n", pid);*/
    
    if (!WIFEXITED(status)) /* fin anormale */
    {
      /* affiche le code d'erreur : marche pas ??? */
      /* je n'aurai surement un code d'erreur que si execve ne dmarre pas
       * il faut donc dtecter les erreurs sans lancer "sh -c" */
      fprintf(stderr, "exit code:%d\n", WEXITSTATUS(status));
    }

    while (xfi[i].has_changed != LAST && xfi[i].pid != pid)
      i++;
    if (xfi[i].pid == pid)
    {
      xfi[i].has_changed = IS_DEADNCHANGED;
      xfi[i].pid = -1;
    }
    else
    {
      fprintf(stderr, "cmd %d introuvable !\n", pid);
    }
  }

  signal(sig, a_child_is_dead);
}

/*
 * used in session module to find the NoteBook widget
 * introduced to be less gtk dependent in other module
 */
GtkNotebook *findNB()
{
  return GTK_NOTEBOOK(lookup_widget(topgtail, "NoteBook"));
}

/* GTK destroy event on top level widget */
gboolean
on_gtail_destroy_event                 (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
#if 0
  puts("destroy");
  if (YNYES == options[which_opt].remember_window_placement)
  {
    gint x, y;
    gdk_window_get_position (topgtail->window, &x, &y);
    printf("XxY: %dx%d\n", x, y);
  }
#endif
  gtk_main_quit();

  return FALSE;
}


/* GTK delete event on top level widget */
gboolean
on_gtail_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
#if 0
  puts("delete");
  if (YNYES == options[which_opt].remember_window_placement)
  {
    gint x, y;
    gdk_window_get_position (topgtail->window, &x, &y);
    printf("XxY: %dx%d\n", x, y);
  }
#endif
  gtk_main_quit();

  return FALSE;
}


void
on_FileMenu_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


/* DO NOT rely on menuitem parameter ! */
void
on_OpenMenuItem_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  static GtkWidget *fileselect = NULL;

  /* cre le toplevel fileselector la premiere fois */
  if (!fileselect)
    fileselect = create_FileSelector ();
  /* montre le */
  gtk_widget_show(fileselect);
}


/* DO NOT rely on menuitem parameter ! */
void
on_CmdMenuItem_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  static GtkWidget *cmdselect = NULL;

  /* cre le toplevel cmdselector la premiere fois */
  if (!cmdselect)
    cmdselect = create_CmdWindow ();
  /* montre le */
  gtk_widget_show(cmdselect);
}


/* DO NOT rely on menuitem parameter ! */
void
on_QuitMenuItem_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_HelpMenu_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_AboutMenuItem_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_ButtonOpenFile_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  on_OpenMenuItem_activate(NULL, user_data);
}


void
on_ButtonExec_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  on_CmdMenuItem_activate(NULL, user_data);
}


void
on_ButtonQuit_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  on_QuitMenuItem_activate(NULL, user_data);
}


/* OOOOOOOOOOOOh le gros hack !
 * je veux pouvoir cliquer sur le tab_label du notebook pour dtruire une page
 * mais je ne peux pas installer un signal click dessus. je peux par contre
 * rcuprer tous les signaux du notebook, il ne faut donc enlever la page que
 * si j'ai clicker sur un tab_label et pas ailleurs. pour savoir a, j'utilise
 * une variable gloable last_switched_page qui est mise  jour par le signal
 * switch_page du notebook (donc j'ai clicker sur un tab_label). cette variable
 * contient le numro de la dernire page visit. il faut la remettre  -1 pour
 * l'invalider et indiquer qu'on a pas fait un switch_page juste avant.
 * BUG : pas possible de supprimer la page en cours et en paticulier, la
 *       dernire page
 */
static gint last_switched_page = -1;

gboolean
remove_page                            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  GdkEventButton *e = (GdkEventButton *)event;

  if (last_switched_page != -1 &&
      e->type == GDK_BUTTON_RELEASE && e->button == 3)
  {
#if 0
    printf("remove page:%d\n", last_switched_page);
#endif
    remove_file(last_switched_page);
    gtk_notebook_remove_page( GTK_NOTEBOOK(widget), last_switched_page );
    last_switched_page = -1;
    return TRUE;
  }

  return FALSE; /* pas trait */
}

/*
 * GTK callback indicating a new page is displayed
 * I use this to change the display status (user notify of buffer modification)
 * and to destroy a page (in a bad way because the GTK NoteBook don't let me
 * know when I click on a tab label).
 */
void
on_NoteBook_switch_page                (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{
  char *name = NULL;

#if 0
  printf("on_NoteBook_switch_page:switching to page %d:%s\n",
	 page_num, xfi[page_num].filename);
#endif
  last_switched_page = page_num;
  switch(xfi[page_num].has_changed)
  {
  case NOT_CHANGED: /* rien  faire */
  case IS_DEAD:
    break;
  case CHANGED: /* passer dans l'tat NOT_CHANGED */
    xfi[page_num].has_changed = NOT_CHANGED;
    /* ot l'*  la fin du label */
    /*name = strdup(xfi[page_num].filename);*/
    name = xtbasename(xfi[page_num].filename);
    if (strlen(name) == 0) /* exemple : commande "find /" */
      name = xfi[page_num].filename;
    gtk_notebook_set_tab_label_text (notebook, GTK_WIDGET(page->child), name);
#if 0
    printf("on_NoteBook_switch_page:changed tab label to : %s\n", name);
#endif
    free(name);
    break;
  case IS_DEADNCHANGED:
    xfi[page_num].has_changed = IS_DEAD;
    /* ot l'*  la fin du label */
    /*name = strdup(xfi[page_num].filename);*/
    name = xtbasename(xfi[page_num].filename);
    if (strlen(name) == 0) /* exemple : commande "find /" */
    {
      name = (char *)realloc(name, strlen(xfi[page_num].filename) + 3);
      strcpy(name, xfi[page_num].filename);
    }
    else
      name = (char *)realloc(name, strlen(name) + 3);
    strcat(name, " X");
    gtk_notebook_set_tab_label_text (notebook, GTK_WIDGET(page->child), name);
#if 0
    printf("on_NoteBook_switch_page:changed tab label to dead : %s\n", name);
#endif
    free(name);
    break;
  default: /* ooops on clique sur une page que j'ai pas ouvert !!! */
    fprintf(stderr, "on_NoteBook_switch_page:switch sur un xfi vide !: ind=%d, has_changed=%d\n", page_num, xfi[page_num].has_changed);
  }
}

/* Click sur l'ajout dans le slecteur de fichier */
void
on_AddButton_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  char fileline[1024];
  GtkWidget *notebook, *fileselect;
  static int reenter = 0;

  if (reenter == 1)
  {
    printf("oooops, on_AddButton_clicked reenter !!!\n");
    return;
  }
  reenter = 1;

  /* trouve une rfrence sur le fileselector */
  fileselect = lookup_widget(GTK_WIDGET(button), "FileSelector");

  /* on est pas dans le bon toplevel -> topgtail */
  notebook = lookup_widget(topgtail, "NoteBook");

  /* rcupre le nom du fichier slectionner */
  strcpy(fileline,
	 gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselect)));

  AddNoteBookPage(GTK_NOTEBOOK(notebook), fileline, 0);

  reenter = 0;
}


void
on_CloseButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fs;

  fs = lookup_widget(GTK_WIDGET(button), "FileSelector");

  gtk_widget_hide(fs);
}

#if 0
gint
repeat_timeout( gpointer data )
{
  
  return TRUE;
}
#endif

/* the user hit the OK button in the 'choose command' dialog */
void
on_cmd_choosed_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  char cmdline[1024];
  GtkWidget *notebook, *cmdname;
  int ind;
  static int reenter = 0;

  if (reenter == 1)
  {
    printf("oooops, on_AddButton_clicked reenter !!!\n");
    return;
  }
  reenter = 1;

  /* trouve une rfrence sur l'entry cmdname */
  cmdname = lookup_widget(GTK_WIDGET(button), "CmdName");

  /* on est pas dans le bon toplevel -> topgtail */
  notebook = lookup_widget(topgtail, "NoteBook");

  /* rcupre le nom du fichier slectionner */
  strcpy(cmdline, gtk_entry_get_text(GTK_ENTRY(cmdname)));
  /*printf("on_button1_clicked:cmd:%s\n", cmdline);*/
  ind = AddNoteBookPage(GTK_NOTEBOOK(notebook), cmdline, 1);
#if 0
  if (ind != -1)
  {
    if (gtk_toggle_button_get_active(lookup_widget(cmdname,
						   "CheckButtonRepeat")))
    {
      xfi[ind].repeat_time = gtk_range_get_adjustment(lookup_widget(cmdname, "ScaleRepeat"))->value;
      xfi[ind].timer = gtk_timeout_add(xfi[ind].repeat_time * 1000,
				       repeat_timeout, ind);
    }
    else
      xfi[ind].repeat_time = 0; /* do not repeat */
    /*xfi[ind].elapse_time = 0;*/
    /*printf("%d\n", xfi[ind].repeat_time);*/
  }
#endif
  reenter = 0;
}


void
on_cmd_abort_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *fs;

  fs = lookup_widget(GTK_WIDGET(button), "CmdWindow");

  gtk_widget_hide(fs);
}

/*
 * Dans le dialog du choix d'une commande, (des)active la sensibilit du scale
 * pour choisir le nombre de seconde en fonction de l'tat du checkbutton
 * associ
 */
void
on_CheckButtonRepeat_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkWidget *scale;

  scale = lookup_widget(GTK_WIDGET(togglebutton), "ScaleRepeat");
  gtk_widget_set_sensitive (scale, !GTK_WIDGET_IS_SENSITIVE(scale));
}

